Wooden Sticks---hdu1051(最长上升子序列)

http://acm.hdu.edu.cn/showproblem.php?pid=1051

Problem Description
There is a pile of n wooden sticks. The length and weight of each stick are known in advance. The sticks are to be processed by a woodworking machine in one by one fashion. It needs some time, called setup time, for the machine to prepare processing a stick. The setup times are associated with cleaning operations and changing tools and shapes in the machine. The setup times of the woodworking machine are given as follows: 

(a) The setup time for the first wooden stick is 1 minute. 
(b) Right after processing a stick of length l and weight w , the machine will need no setup time for a stick of length l' and weight w' if l<=l' and w<=w'. Otherwise, it will need 1 minute for setup. 

You are to find the minimum setup time to process a given pile of n wooden sticks. For example, if you have five sticks whose pairs of length and weight are (4,9), (5,2), (2,1), (3,5), and (1,4), then the minimum setup time should be 2 minutes since there is a sequence of pairs (1,4), (3,5), (4,9), (2,1), (5,2).
 
Input
The input consists of T test cases. The number of test cases (T) is given in the first line of the input file. Each test case consists of two lines: The first line has an integer n , 1<=n<=5000, that represents the number of wooden sticks in the test case, and the second line contains n 2 positive integers l1, w1, l2, w2, ..., ln, wn, each of magnitude at most 10000 , where li and wi are the length and weight of the i th wooden stick, respectively. The 2n integers are delimited by one or more spaces.
 
Output
The output should contain the minimum setup time in minutes, one per line.
 
Sample Input
3
5
4 9 5 2 2 1 3 5 1 4
3
2 2 1 1 2 2
3
1 3 2 2 3 1
 
Sample Output
2 1 3
这道题刚开始并不知道怎么写   丝毫没有思路  后来发现这不就是上升子序列么
但是还是忘了怎么写   就翻了之前的博客有调试一下才看懂
发现真是学的不快忘得挺快   唉  
#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<queue>

using namespace std;

#define N 5500
struct node
{
    int u,v;
}a[N];

int cmp(const void *x,const void *y)
{
    struct node *c,*d;
    c=(struct node *)x;
    d=(struct node *)y;
    if(c->u!=d->u)
        return d->u-c->u;
    else
        return d->v-c->v;
}
int main()
{
    int T,n;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d",&n);
        for(int i=0;i<n;i++)
        {
            scanf("%d %d",&a[i].u,&a[i].v);
        }
        qsort(a,n,sizeof(a[0]),cmp);
        int dp[N];
        int Max=0;
        for(int i=0;i<n;i++)
        {
            dp[i]=1;
            for(int j=0;j<i;j++)
            {
                if(a[i].v>a[j].v && dp[j]+1>dp[i])
                    dp[i]=dp[j]+1;
            }
            if(dp[i]>dp[Max])
                Max=i;
        }
        printf("%d
",dp[Max]);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/linliu/p/5363398.html